openerp.report_invoice_utility = function (instance, local) {

    local.ReportWidget = instance.Widget.extend({
        template: 'ReportContainerTemplate1',
        invoices: [],
        invoiceLines: [],
        productProduct:[],
        Currency:[],

        start: function () {
          this.fetchJournal();
          this.$el.find('#report_form').submit(_.bind(this.submitForm, this));
        },
        // Buscar Diario
        fetchJournal: function () {
          var self = this;
            var Journal = new instance.web.Model('account.journal');
            Journal.query(['id', 'type', 'code', 'currency', 'name', 'company_id', 'active']).filter([['type', '=', 'sale'], ['active', '=', true]]).all().then(function (results) {
                self.journal = results;
                _.each(results, function (item) {
                  self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                self.$el.find('#current-journal').append('<option value="9999999">TODAS LAS SUC.</option>');
            });
        },

        fetchCurency: function () {
            var defer = $.Deferred();
            var currency_Rate = new instance.web.Model('res.currency.rate');
            fields = ['id', 'name', 'currency_id', 'rate', 'create_date'];
            domain = [['currency_id', '=', [166 , 20, 7, 3]]];
            currency_Rate.query(fields).filter(domain).all().then(function (results) {
              defer.resolve(results);
            });
            return defer;
          },

        // Invoice (FACTURAS)
        fetchInvoiceV2: function (journalId) {
            var domain = null;
            if( journalId == 9999999){
              domain = [['state', '=',['open','paid']],['type', '=', 'out_invoice']];
            }else{
              domain = [['state', '=',['open','paid']],['type', '=', 'out_invoice'],['journal_id.id', '=', journalId]];
            }

            var defer = $.Deferred();

            var Invoice = new instance.web.Model('account.invoice');
            Invoice.query(['id', 'type', 'number', 'origin', 'state', 'journal_id', 'currency_id', 'invoice_line']).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },
        // Invoice line (Linea de Factura)
        fetchInvoiceLine: function (invoices) {
          var defer = $.Deferred();
          var linesIds = _.flatten(_.map(invoices, function (item) {
            return item.invoice_line;
          }));

          var InvoiceLine = new instance.web.Model('account.invoice.line');
          InvoiceLine.query(['id', 'quantity', 'price_unit', 'discount', 'name', 'product_id', 'origin','invoice_id']).filter([['id', 'in', linesIds]]).all().then(function (results) {
            defer.resolve(results)
          });

          return defer;
        },
        // Product Product
        fecthProduct: function(invoiceLines){
          var defer = $.Deferred();
          var porductIDS = _.flatten(_.map(invoiceLines, function (item) {
            return item.product_id[0];
          }));

          var ProductProdcut =  new instance.web.Model('product.product');
          var fields = ['id', 'default_code', 'name_template', 'factory_code', 'factory_reference', 'factory_barcode', 'standard_price'];
          ProductProdcut.query(fields).filter([['id', 'in', porductIDS]]).all().then(function (results) {
            defer.resolve(results)
          });

          return defer;
        },

        // Cansultar
        submitForm: function (e) {
            e.preventDefault();
            var formData = this.$(e.currentTarget).serializeJSON();
            if (formData.journal == 0) {
                $("#dialog" ).dialog({
                    autoOpen: true,
                    resizable: false,
                    modal: true,
                    title: 'Atención',
                    open: function() {
                        $(this).html('Complete el formulario para generar el reporte');
                    },
                    show: {
                        effect: "shake",
                        duration: 300
                    },
                    hide: {
                        effect: "fade",
                        duration: 300
                    },
                    buttons: {
                        Aceptar: function() {
                            $(this).dialog('close');
                        }
                    }
                });
                return;
            }
            this.fetchCurency().then(function(currency) {
                self.Currency = currency;
            });
            var self = this;
            this.fetchInvoiceV2(formData.journal).then(function (invoices) {
              self.invoices = invoices;
              return invoices;
            }).then(function (invoices) {
                return self.fetchInvoiceLine(invoices);
            }).then(function (invoiceLines) {
                self.invoiceLines = invoiceLines;
                return self.fecthProduct(invoiceLines);
            }).then(function(productProduct){
              self.productProduct = productProduct;
              return self.invoice_Currency();
            });

            return false;
        },

        invoice_Currency: function(){
          var currency_new = null;
          for (var i = 0; i < this.invoices.length; i++) {
              item = this.invoices[i];
              currency_new = _.find(this.Currency, function(curr){
                  return _.contains(curr.currency_id, item.currency_id[0]);
                });
                if (!currency_new){
                  currency_new={};
                  currency_new.rate=1;
                }
                this.invoices[i].rate=(currency_new.rate);
          }
            return this.fectUtility();
        },

        fectUtility: function(){
          var data = [];
          var item = null;
          var invoice = null;
          var producto =null;

          for (var i = 0; i < this.invoiceLines.length; i++) {
            item = this.invoiceLines[i];

            invoice = _.find(this.invoices, function (inv) {
              return _.contains(inv.invoice_line, item.id);
            });
            producto =_.find(this.productProduct, function(prod){
              return _.contains(item.product_id, prod.id);
            });
            if (!producto){
              producto={};
              producto.standard_price=0;
            }

            data.push({number : (invoice.number),
                       name : (item.name),
                       quantity : (item.quantity),
                       price_unity : (item.price_unit.toFixed(2) / invoice.rate.toFixed(2)),
                       standar_price : (producto.standard_price.toFixed(2)),
                       price_tot : (item.quantity * (item.price_unit.toFixed(2) / invoice.rate.toFixed(2))),
                       standar_tot : (item.quantity * producto.standard_price.toFixed(2)),
                       utility : ((item.quantity * (item.price_unit.toFixed(2) / invoice.rate.toFixed(2))) - (item.quantity * producto.standard_price)).toFixed(2)});

          }
          this.drawPDF(data);
        },

        drawPDF: function (rows) {
          rows2=[];
            var sucusal = this.sucDescrip = this.$el.find('#current-journal option:selected').text();
            var totalPagesExp = "{total_pages_count_string}";
            getColumns = [
                    {title: "Factura", dataKey: "number"},
                    {title: "Producto", dataKey: "name"},
                    {title: "Cantidad", dataKey: "quantity"},
                    {title: "Precio Unitario", dataKey: "price_unity"},
                    {title: "Precio Costo", dataKey: "standar_price"},
                    {title: "Total Venta", dataKey: "price_tot"},
                    {title: "Total Costo", dataKey: "standar_tot"},
                    {title: "Utilidad", dataKey: "utility"}
                ];

            var pdfDoc = new window.jsPDF();
            var quantity=precio_cost=precio_unit=tol_cost=tot_unit=utility=0;
            _.each(rows, function (datos) {
              quantity  += datos.quantity;
              precio_unit += datos.price_unity;
              precio_cost += parseFloat(datos.standar_price);
              tot_unit += datos.price_tot;
              tol_cost += datos.standar_tot;
              utility += parseFloat(datos.utility);
            });

            rows.push({ number : "  ",
                        name : "TOTAL  USD  ",
                        quantity: quantity,
                        price_unity : precio_unit.toFixed(2),
                        standar_price : precio_cost.toFixed(2),
                        price_tot : tot_unit.toFixed(2),
                        standar_tot : tol_cost.toFixed(2),
                        utility : utility.toFixed(2)});

            rows.unshift({ number : "  ",
                        name : "TOTAL  USD  ",
                        quantity: quantity,
                        price_unity : precio_unit.toFixed(2),
                        standar_price : precio_cost.toFixed(2),
                        price_tot : tot_unit.toFixed(2),
                        standar_tot : tol_cost.toFixed(2),
                        utility : utility.toFixed(2)});

            _.each(rows, function (rows1) {
                  rows2.push({  number : rows1.number,
                                name : rows1.name,
                                quantity: accounting.formatNumber(rows1.quantity,0, ".", ","),
                                price_unity : accounting.formatNumber(rows1.price_unity, 2, ".", ","),
                                standar_price : accounting.formatNumber(rows1.standar_price, 2, ".", ","),
                                price_tot : accounting.formatNumber(rows1.price_tot, 2, ".", ","),
                                standar_tot : accounting.formatNumber(rows1.standar_tot, 2, ".", ","),
                                utility :accounting.formatNumber(rows1.utility, 2, ".", ",")});
            });

            pdfDoc.autoTable(getColumns, rows2, {

                theme: 'striped', // 'striped', 'grid' or 'plain',
                // startY: pdfDoc.autoTable.previous.finalY + 15,
                // margin: {},
                // tableLineWidth: 0.75,
                styles: { overflow: 'hidden',
                          fontSize: 7,
                          columnWidth: 'wrap'},
                columnStyles: {
                            // text: {columnWidth: 'auto'},
                              number: {fontStyle: 'bold'},
                              name :{columnWidth: '10px'},
                              quantity :{halign:'right' },
                              price_unity : {halign:'right' },
                              standar_price : {halign:'right' },
                              price_tot : {halign:'right' },
                              standar_tot : {halign:'right' },
                              utility : {halign:'right'},

                            },

                margin: { top: 15, horizontal: 7},

                addPageContent: function (data) {
                    pdfDoc.text('Análisis de Utilidad '+ sucusal, 10, 10);
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(7);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 10);
                }

            });
            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Analisis de utilidad.pdf')
            // pdfDoc.output('dataurlnewwindow');
        },

    });
    instance.web.client_actions.add('report_invoice_utility.action_report', 'instance.report_invoice_utility.ReportWidget');
}
